# encoding: utf-8
require 'yaml'
require 'ya2yaml'
require 'zlib'
require 'archive/tar/minitar'
require 'pinkyblog/application/core'

module PinkyBlog
	class Application
		def export_to_yaml
			@repository.lock{
				entries = @repository.load_all_entries
				entries.sort!{|a, b| a.id <=> b.id}
				open('exported.yaml', 'w'){|output|
				Zlib::GzipWriter.open('exported.yaml.gz'){|gz_output|
					
					entries.each do |entry|
						data = {}
						data['Title'] = entry.title
						data['Visible'] = entry.visible
						data['ID'] = entry.id
						data['Body'] = entry.content
						data['Updated'] = entry.last_modified
						data['Created'] = entry.created

						
						data['Images'] = []
						load_attached_images(entry.id).each do |image|
							body = (@config.attached_dir_path + "#{entry.id}_#{image.name}").read
							
							data['Images'] << {'Name' => image.name, 'Body' => [body].pack('m*')}
						end
						
						data['Comments'] = []
						entry.comments.each do |comment|
							data['Comments'] << {
								'Body' => comment.content,
								'Writer' => comment.writer,
								'Time' => comment.time,
								'UUID' => comment.uuid,
								'Edited-Number' => comment.edited_number,
								'Password-SHA' => comment.password_sha,
							}
						end
						
						output.puts data.ya2yaml
						gz_output.puts data.ya2yaml
					end
				}
				}
			}
		end
	end
end